import type { SafeEquals } from "../../types/SafeEquals.js";
import type { SafeFrom } from "../../types/SafeFrom.js";
interface BooleanObject {
    value: boolean;
}
interface Boolean {
    boolean: boolean;
    value: boolean;
    postgres: string;
    toString(): string;
    toNumber(): number;
    toBoolean(): boolean;
    toJSON(): BooleanObject;
    equals(number: number): boolean;
    equals(string: string): boolean;
    equals(boolean: boolean): boolean;
    equals(object: Boolean | BooleanObject): boolean;
    safeEquals(number: number): SafeEquals<Boolean>;
    safeEquals(string: string): SafeEquals<Boolean>;
    safeEquals(boolean: boolean): SafeEquals<Boolean>;
    safeEquals(object: Boolean | BooleanObject): SafeEquals<Boolean>;
}
interface BooleanConstructor {
    from(number: number): Boolean;
    from(string: string): Boolean;
    from(boolean: boolean): Boolean;
    from(object: Boolean | BooleanObject): Boolean;
    safeFrom(number: number): SafeFrom<Boolean>;
    safeFrom(string: string): SafeFrom<Boolean>;
    safeFrom(boolean: boolean): SafeFrom<Boolean>;
    safeFrom(object: Boolean | BooleanObject): SafeFrom<Boolean>;
    /**
     * Returns `true` if `object` is a `Boolean`, `false` otherwise.
     */
    isBoolean(object: any): object is Boolean;
}
declare const Boolean: BooleanConstructor;
export { Boolean, BooleanConstructor, BooleanObject };
