import type { SafeEquals } from "../../types/SafeEquals.js";
import type { SafeFrom } from "../../types/SafeFrom.js";
import { UUID } from "../UUID/UUID.js";
import { Character } from "./Character.js";
import { CharacterVarying } from "./CharacterVarying.js";
import { Text } from "./Text.js";
interface NameObject {
    value: string;
}
interface Name {
    name: string;
    value: string;
    postgres: string;
    toString(): string;
    toJSON(): NameObject;
    equals(string: string): boolean;
    equals(object: Character<number> | CharacterVarying<number> | Name | Text | UUID | NameObject): boolean;
    safeEquals(string: string): SafeEquals<Name>;
    safeEquals(object: Character<number> | CharacterVarying<number> | Name | Text | UUID | NameObject): SafeEquals<Name>;
}
interface NameConstructor {
    from(string: string): Name;
    from(object: Character<number> | CharacterVarying<number> | Name | Text | UUID | NameObject): Name;
    safeFrom(string: string): SafeFrom<Name>;
    safeFrom(object: Character<number> | CharacterVarying<number> | Name | Text | UUID | NameObject): SafeFrom<Name>;
    /**
     * Returns `true` if `object` is a `Name`, `false` otherwise.
     */
    isName(object: any): object is Name;
}
declare const Name: NameConstructor;
export { Name, NameConstructor, NameObject };
