import type { SafeEquals } from "../../types/SafeEquals.js";
import type { SafeFrom } from "../../types/SafeFrom.js";
import { UUID } from "../UUID/UUID.js";
import { Character } from "./Character.js";
import { CharacterVarying } from "./CharacterVarying.js";
import { Name } from "./Name.js";
interface TextObject {
    value: string;
}
interface Text {
    text: string;
    value: string;
    postgres: string;
    toString(): string;
    toJSON(): TextObject;
    equals(string: string): boolean;
    equals(object: Character<number> | CharacterVarying<number> | Name | Text | UUID | TextObject): boolean;
    safeEquals(string: string): SafeEquals<Text>;
    safeEquals(object: Character<number> | CharacterVarying<number> | Name | Text | UUID | TextObject): SafeEquals<Text>;
}
interface TextConstructor {
    from(string: string): Text;
    from(object: Character<number> | CharacterVarying<number> | Name | Text | UUID | TextObject): Text;
    safeFrom(string: string): SafeFrom<Text>;
    safeFrom(object: Character<number> | CharacterVarying<number> | Name | Text | UUID | TextObject): SafeFrom<Text>;
    /**
     * Returns `true` if `object` is a `Text`, `false` otherwise.
     */
    isText(object: any): object is Text;
}
declare const Text: TextConstructor;
export { Text, TextConstructor, TextObject };
