import type { SafeEquals } from "../../types/SafeEquals.js";
import type { SafeFrom } from "../../types/SafeFrom.js";
interface BoxObject {
    x1: number;
    y1: number;
    x2: number;
    y2: number;
}
interface Box {
    x1: number;
    y1: number;
    x2: number;
    y2: number;
    value: string;
    postgres: string;
    toString(): string;
    toJSON(): BoxObject;
    equals(string: string): boolean;
    equals(object: Box | BoxObject): boolean;
    equals(x1: number, y1: number, x2: number, y2: number): boolean;
    safeEquals(string: string): SafeEquals<Box>;
    safeEquals(object: Box | BoxObject): SafeEquals<Box>;
    safeEquals(x1: number, y1: number, x2: number, y2: number): SafeEquals<Box>;
}
interface BoxConstructor {
    from(string: string): Box;
    from(object: Box | BoxObject): Box;
    from(x1: number, y1: number, x2: number, y2: number): Box;
    safeFrom(string: string): SafeFrom<Box>;
    safeFrom(object: Box | BoxObject): SafeFrom<Box>;
    safeFrom(x1: number, y1: number, x2: number, y2: number): SafeFrom<Box>;
    /**
     * Returns `true` if `object` is a `Box`, `false` otherwise.
     */
    isBox(object: any): object is Box;
}
declare const Box: BoxConstructor;
declare function isBox(object: any): object is Box | BoxConstructor;
export { Box, BoxConstructor, BoxObject, isBox };
