import type { SafeEquals } from "../../types/SafeEquals.js";
import type { SafeFrom } from "../../types/SafeFrom.js";
interface LineObject {
    a: number;
    b: number;
    c: number;
}
interface Line {
    a: number;
    b: number;
    c: number;
    value: string;
    postgres: string;
    toString(): string;
    toJSON(): LineObject;
    equals(string: string): boolean;
    equals(object: Line | LineObject): boolean;
    equals(a: number, b: number, c: number): boolean;
    safeEquals(string: string): SafeEquals<Line>;
    safeEquals(object: Line | LineObject): SafeEquals<Line>;
    safeEquals(a: number, b: number, c: number): SafeEquals<Line>;
}
interface LineConstructor {
    from(string: string): Line;
    from(object: Line | LineObject): Line;
    from(a: number, b: number, c: number): Line;
    safeFrom(string: string): SafeFrom<Line>;
    safeFrom(object: Line | LineObject): SafeFrom<Line>;
    safeFrom(a: number, b: number, c: number): SafeFrom<Line>;
    /**
     * Returns `true` if `object` is a `Line`, `false` otherwise.
     */
    isLine(object: any): object is Line;
}
declare const Line: LineConstructor;
export { Line, LineConstructor, LineObject };
