import type { SafeEquals } from "../../types/SafeEquals.js";
import type { SafeFrom } from "../../types/SafeFrom.js";
interface PointObject {
    x: number;
    y: number;
}
interface Point {
    x: number;
    y: number;
    value: string;
    postgres: string;
    toString(): string;
    toJSON(): PointObject;
    equals(string: string): boolean;
    equals(object: Point | PointObject): boolean;
    equals(x: number, y: number): boolean;
    safeEquals(string: string): SafeEquals<Point>;
    safeEquals(object: Point | PointObject): SafeEquals<Point>;
    safeEquals(x: number, y: number): SafeEquals<Point>;
}
interface PointConstructor {
    from(string: string): Point;
    from(object: Point | PointObject): Point;
    from(x: number, y: number): Point;
    safeFrom(string: string): SafeFrom<Point>;
    safeFrom(object: Point | PointObject): SafeFrom<Point>;
    safeFrom(x: number, y: number): SafeFrom<Point>;
    /**
     * Returns `true` if `object` is a `Point`, `false` otherwise.
     */
    isPoint(object: any): object is Point;
}
declare const Point: PointConstructor;
export { Point, PointConstructor, PointObject };
