import { Address4, Address6 } from "ip-address";
import { IPVersion, IPVersionType } from "../../types/IpType.js";
interface IPAddressObject {
    IPAddress: string;
}
interface IPAddress {
    toString(): string;
    toJSON(): IPAddressObject;
    equals(otherIPAddress: string | IPAddress | IPAddressObject): boolean;
    IPAddress: string;
    readonly IPAddressMinusSuffix: string;
    readonly version: IPVersion | IPVersionType;
    readonly subnet: string;
    readonly subnetMask: number;
    readonly startAddress: IPAddress;
    readonly endAddress: IPAddress;
    /**
     * @param otherIPAddress The IP address to compare to.
     * @returns `true` if the given IP address is in the subnet of this IP address.
     */
    contains(otherIPAddress: string | IPAddress | IPAddressObject): boolean;
    toIPAddress4(): Address4 | null;
    toIPAddress6(): Address6 | null;
}
interface IPAddressConstructor {
    from(data: IPAddress | IPAddressObject): IPAddress;
    from(string: string): IPAddress;
    /**
     * Returns `true` if `object` is a `IPAddress`, `false` otherwise.
     */
    isIPAddresss(object: any): object is IPAddress;
}
declare const IPAddress: IPAddressConstructor;
export { IPAddress, IPAddressConstructor, IPAddressObject };
